public class UE13Aufgabe13 {

	public static void main(String[] args) {
		Radio radio = new Radio();
		System.out.println(radio.makeString());
		radio.an();
		radio.lauter();
		radio.aus();
		radio.lauter();
		radio.an();
		radio.waehleSender(90.0);
		System.out.println(radio.makeString());

		Fernseher tv = new Fernseher();
		System.out.println(tv.makeString());
		tv.an();
		tv.lauter();
		tv.aus();
		tv.lauter();
		tv.an();
		tv.waehleKanal(3);
		System.out.println(tv.makeString());
	}

}

class RundfunkEmpfangsGeraet {
	int lautstaerke;
	boolean eingeschaltet;

	RundfunkEmpfangsGeraet() {
		this.lautstaerke = 0;
		this.eingeschaltet = false;
	}

	/**
	 * Veraendere Lautstaerke um x (nach oben oder unten, je nach Vorzeichen von
	 * x).
	 */
	void volume(int x) {
		if (this.eingeschaltet) {
			this.lautstaerke += x;
		}
	}

	/** Erhoehe Lautstaerke um 1. */
	void lauter() {
		if (this.eingeschaltet) {
			this.lautstaerke++;
		}
	}

	/** Liefere Lautstaerke zurueck. */
	int getLautstaerke() {
		return this.lautstaerke;
	}

	/** Vermindere Lautstaerke um 1. */
	void leiser() {
		if (this.eingeschaltet) {
			this.lautstaerke--;
		}
	}

	/** Schalte ein. */
	void an() {
		this.eingeschaltet = true;
	}

	/** Schalte aus. */
	void aus() {
		this.eingeschaltet = false;
	}

	/** An oder aus? */
	boolean istAn() {
		return this.eingeschaltet;
	}
}

class Radio extends RundfunkEmpfangsGeraet {
	double frequenz;

	Radio() {
		this.frequenz = 87.5;
	}

	void waehleSender(double newFrequenz) {
		if (this.eingeschaltet) {
			this.frequenz = newFrequenz;
		}
	}

	String makeString() {
		return "Radio: Sender = " + this.frequenz + " Lautstaerke = "
				+ this.lautstaerke + ", Radio ist "
				+ (this.eingeschaltet ? "an" : "aus") + ".";
	}
}

class Fernseher extends RundfunkEmpfangsGeraet {
	int kanal;

	Fernseher() {
		this.kanal = 1;
	}

	void waehleKanal(int newKanal) {
		if (this.eingeschaltet) {
			this.kanal = newKanal;
		}
	}

	String makeString() {
		return "Fernseher: Kanal = " + this.kanal + " Lautstaerke = "
				+ this.lautstaerke + ", Fernseher ist "
				+ (this.eingeschaltet ? "an" : "aus") + ".";
	}
}