
class Stack19 {

	private int[] buffer; // zum Speichern von Daten
	private int current; // aktueller Index

	public Stack19(int size) {
		this.buffer = new int[size];
		this.current = -1;
	}

	public int getSize() {
		return this.buffer.length;
	}

	public boolean isFull() {
		return this.current == this.buffer.length - 1;
	}

	public boolean isEmpty() {
		return this.current == -1;
	}

	public void push(int value) {
		if (!this.isFull()) {
			this.buffer[++this.current] = value;
		}
	}

	public int pop() {
		if (this.isEmpty()) {
			return -1;
		}
		return this.buffer[this.current--];
	}
}

class ToTopStack extends Stack19 {

	public ToTopStack(int size) {
		super(size);
	}

	public boolean toTop(int value) {
		Stack19 buffer = new Stack19(this.getSize());
		while (!this.isEmpty()) {
			int v = this.pop();
			if (v != value) {
				buffer.push(v);
			} else {
				fuellen(buffer);
				push(v);
				return true;
			}

		}
		fuellen(buffer);
		return false;
	}

	private void fuellen(Stack19 buffer) {
		while (!buffer.isEmpty()) {
			this.push(buffer.pop());
		}
	}
}

public class UE13Aufgabe19 {

	public static void main(String[] args) {
		ToTopStack stack = new ToTopStack(50);
		stack.push(1);
		stack.push(2);
		stack.push(3);
		stack.push(2);
		stack.push(4);
		stack.push(5);
		stack.toTop(2);
		stack.push(6);
		while (!stack.isEmpty()) {
			System.out.print(stack.pop() + " ");
		}
	}

}
