class ExtList extends List {

	void addPrev(int v) {
		Element elem = this.first;
		while (elem != this.last) {
			if (elem.next.value == v) {
				elem.value += v;
			}
			elem = elem.next;
		}
	}

	void addPrev2(int v) {
		Element prev = null;
		Element elem = this.first;
		while (elem != null) {
			if (elem.value == v) {
				if (prev != null) {
					prev.value += v;
				}
			}
			prev = elem;
			elem = elem.next;
		}
	}
}

class UE13Aufgabe21 {
	public static void main(String[] args) {
		ExtList list = new ExtList();
		list.append(5);
		list.append(4);
		list.append(4);
		list.append(5);
		list.append(2);
		list.append(2);
		list.append(2);
		list.append(4);
		list.print();
		list.addPrev(4);
		list.print();
	}
}
