class AList extends List {
	AList() {
		super();
	}

	void ansEndeSchieben(int i) { // ans Ende schieben

		// alle Vorkommen entfernen
		int anzahlEntfernt = this.entfernen(i);

		// entfernte Vorkommen wieder hinten anhaengen
		for (int j = 0; j < anzahlEntfernt; j++) {
			this.append(i);
		}
	}

	private int entfernen(int i) { // liefert Anzahl entfernter Elemente
		int anzahlEntfernt = 0;
		Element vorgaenger = null;
		Element zeiger = this.first;

		// alle Elemente durchgehen
		while (zeiger != null) {
			if (zeiger.value == i) { // gefunden
				if (vorgaenger != null) {

					// rausnehmen
					vorgaenger.next = zeiger.next;
				} else { // Element == erstes

					// ueberspringen
					this.first = zeiger.next;
				}
				if (zeiger.next == null) { // u.U. letztes anpassen
					this.last = vorgaenger;
				}
				anzahlEntfernt++;
			} else {
				vorgaenger = zeiger;
			}
			zeiger = zeiger.next;
		}
		return anzahlEntfernt;
	}
}

public class UE13Aufgabe8 {

	// Testprogramm 
	public static void main(String[] args) {
		AList list = new AList();
		list.append(5);
		list.append(4);
		list.append(3);
		list.append(4);
		list.append(4);
		list.append(2);
		list.append(2);
		list.append(1);
		list.print();
		list.ansEndeSchieben(4);
		list.print();
	}

}
